<?php
/**
 * Created by PhpStorm.
 * User: tandunzhao
 * Date: 2017/12/26
 * Time: 下午8:30
 */

namespace App\Http\Controllers\Channel\Finance;


use App\Modules\Finance\Services\WithdrawCashService;
use Illuminate\Http\Request;

class FinanceController extends BaseController
{

    /**
     * @apiVersion 1.0.0
     * @apiDescription 获取状态列表
     * @api {POST} getWithdrawCashStatus 获取状态列表
     * @apiGroup Finance
     * @apiName getWithdrawCashStatus
     * @apiSuccess   {Number}  code 状态码
     * @apiSuccess   {String}  name 状态名称.
     * @apiSuccess   {Number}  show 是否显示 0:隐藏; 1:显示
     * @apiSuccessExample {json} Success-Response:
     *
     *     {
     *         "code": 0,
     *         "msg": "",
     *         "data":[
     *                  {
     *                      "code": 0,
     *                      "name": "待审核",
     *                      "show": 1
     *                  }
     *              ]
     *     }
     */
    public function getWithdrawCashStatus(Request $request) {
        $result = WithdrawCashService::getWithdrawCashStatusList(10);
        return response()->success($result);
    }

}